package net.eduvax.sched;

public class Schedulable implements Runnable, Comparable<Schedulable> {
	/** time to trig Runnable execution */
	private long _trigTime=0;
	/** Runnable to execute */
	private Runnable _toRun;
	/** Period for repetitive schedule */
	private long _period=0;
	/** 
	 * Create new time trigged runnable from
	 * a runnable.
	 * @param trigTime time 
	 * trigTime is relative to the clock that drives the
	 * sequencing where the TimeTriggedRunnable are scheduled.
	 * trigTime should be milliseconds, but once againe, it's the matter
	 * of what squedules TTRs to define its time reference.
	 * @param toRun Runnable to be launch at due time.
	 */
	public Schedulable(long time, Runnable toRun) {
		_trigTime=time;
		_toRun=toRun;
	}
	public Schedulable(long time, long period, Runnable toRun) {
		_trigTime=time;
		_toRun=toRun;
		_period=period;
	}
	/**
	 * Comparable implementation.
	 * For now only time is considered, some prority may be introduced in
	 * the future.
	 * @param o TTR to compare with.
	 */
	public int compareTo(Schedulable o) {
		return (int)(_trigTime-o._trigTime);
	}
	// Runnable implementation
	public void run() {
		_toRun.run();
		if (_period>0) {
			_trigTime+=_period;
		}
	}
	// Properties getters
	public long getPeriod() {
		return _period;
	}
	public long getTrigTime() {
		return _trigTime;
	}
}
