package test;

import net.eduvax.sched.Schedulable;
import net.eduvax.sched.Sequencer;
import org.junit.*;
import static org.junit.Assert.*;

class TestTask extends Schedulable {
	private long _execTime;
	public TestTask(long trigTime) {
		super(trigTime,null);
		_execTime=-1;
	}
	public void run() {
		_execTime=System.currentTimeMillis();
	}
	long getExecTime() {
		return _execTime;
	}
}

public class TestSequencer {
	private Sequencer _sequencer;
	private final static long MAXRANGE=5;

	private boolean checkTime(long ref,long val) {
		long delay=val-ref;
		System.out.println(""+delay);
		return delay<MAXRANGE && delay>-MAXRANGE;
	}

	@Before public void setUp() {
		_sequencer=new Sequencer();
	}

	@After public void tearDown() {
	}

	@Test public void testSeq() {
		long[] delays={1000L,1500L,2000L,3000L,2750L,2000L,500L,1250L};
		long startTime=System.currentTimeMillis();
		TestTask[] tasks=new TestTask[delays.length];
		for (int i=0;i<tasks.length;i++) {
			delays[i]+=startTime;
			tasks[i]=new TestTask(delays[i]);
			_sequencer.schedule(tasks[i]);
		}
		_sequencer.schedule(startTime+3000L,new Runnable() {
			public void run() {
				_sequencer.stop();
			}
		});
		_sequencer.run();
		long duration=System.currentTimeMillis()-startTime;
		System.out.print("Duration: "+duration+" / ");
		assertTrue(checkTime(3000L,duration));
		for (int i=0;i<tasks.length;i++) {
			System.out.print("Task "+i+": ");
			assertTrue(checkTime(tasks[i].getTrigTime(),tasks[i].getExecTime()));
		}
	}
}
